//package com.hh.arome.services.omc;
//
//import android.content.Context;
//import android.os.Build;
//
//
///**
// * Created by L470 on 2020/6/8.
// */
//
//public class IDCardScanEngine
////        implements  HdwlC5000IDCardScan.HdwlC5000IDCardScanListener,
////        LklIDCardScan.LklIDCardScanListener
//{
//
//    Context mContext;
//    IAidl mIAidl;
//    AidlCallback mIdCardScanResultCallback;
//
//    private static volatile IDCardScanEngine instance;
//
//    public static IDCardScanEngine getInstance(Context context) {
//        if (instance == null) {
//            synchronized (IDCardScanEngine.class) {
//                if (instance == null) {
//                    instance = new IDCardScanEngine(context);
//                }
//            }
//        }
//        return instance;
//    }
//
//    public IDCardScanEngine(Context context) {
//        this.mContext = context;
//
//        mIAidl = getIDCardScanEngine(context);
//    }
//
//    /**
//     * 根据机型，初始化不同的身份证读取实现
//     * C5000、拉卡拉、Cilico、商米L2
//     *
//     * @param context
//     * @return
//     */
//    public IAidl getIDCardScanEngine(Context context) {
//
//
//        String model = Build.MODEL;
//        LogUtils.e("model:" + model);
//
//        if (Constants.DeviceType.HDWE.equals(model)) {
//            // 汉德霍尔
//            String display = Build.DISPLAY;
//            LogUtils.e("汉德霍尔-DISPLAY", display);
//            if (display.contains(HDWE_C5000)) {
//                // 汉德霍尔-C5000
//                /*HdwlC5000IDCardScan hdwlC5000IDCardScan = new HdwlC5000IDCardScan(context);
//                hdwlC5000IDCardScan.setListener(this);
//                return hdwlC5000IDCardScan;*/
//                return HdwlC5000IDCardScan.getInstance(context);
//            }
//        } else if (Constants.DeviceType.LKL.equals(model)) {
//            // 拉卡拉
//            /*LklIDCardScan lklIDCardScan = new LklIDCardScan(context);
//            lklIDCardScan.setListener(this);
//            return lklIDCardScan;*/
//            return LklIDCardScan.getInstance(context);
//        } else if (Constants.DeviceType.FLY_CILICO.equals(model)) {
//            // 傅立叶-cilico- 云测温PDA
//        } else if (Constants.DeviceType.SUNMI_L2.equals(model)) {
//            // 商米-L2
//            return SunmiL2IDCardScan.getInstance(context);
//        } else if (Constants.DeviceType.SUNMI_V2_pro.equals(model)) {
//            // 商米-V2 pro
//            try {
//                return SunmiL2IDCardScan.getInstance(context);
//            } catch (Exception e) {
//                LogUtils.e("SunmiL2IDCardScan---Exception:"+e.toString());
//                e.printStackTrace();
//            }
//        }
//        return null;
//    }
//
//    public void startScanIDCard(IDCardScanResultCallback idCardScanResultCallback) {
//
//        this.mIdCardScanResultCallback = idCardScanResultCallback;
//
//        mIAidl.startIDCardScan(idCardScanResultCallback);
//    }
//
//    public void resumeScanIDCard() {
//        LogUtils.e("IDCardScanEngine--resumeScanIDCard");
//        mIAidl.resumeIDCardScan();
//    }
//
//    public void pauseScanIDCard(){
//        LogUtils.e("IDCardScanEngine--pauseScanIDCard");
//        mIAidl.pauseIDCardScan();
//    }
//
//    public void stopScanIDCard() {
//        LogUtils.e("IDCardScanEngine--stopScanIDCard");
//        mIAidl.stopIDCardScan();
//    }
//
//    public void destoryIDCardScan() {
//        LogUtils.e("IDCardScanEngine--destoryIDCardScan");
//        mIAidl.destoryIDCardScan();
//        instance = null;
//    }
//
//    /*@Override
//    public void onStart() {
//        LogUtils.e("IDCardScanEngine--onStart");
//    }
//
//    @Override
//    public void onPause() {
//        LogUtils.e("IDCardScanEngine--onPause");
//        this.stopScanIDCard();
//    }
//
//    @Override
//    public void onStop() {
//        LogUtils.e("IDCardScanEngine--onStop");
//        this.stopScanIDCard();
//    }
//
//    @Override
//    public void onDestroy() {
//        LogUtils.e("IDCardScanEngine--onDestroy");
//        this.destoryIDCardScan();
//    }*/
//
//
//    /*@Override
//    public void hdwlC5000IDCardScanSuccess(IDCardInfoBean idCardInfoBean) {
//        mIdCardScanResultCallback.onIDCardScanSuccess(idCardInfoBean);
//    }
//
//    @Override
//    public void hdwlC5000IDCardScanError(String errorCode, String errorMsg) {
//        mIdCardScanResultCallback.onIDCardError(errorCode,errorMsg);
//    }*/
//
//
//    /*@Override
//    public void lklIDCardScanSuccess(IDCardInfoBean idCardInfoBean) {
//        mIdCardScanResultCallback.onIDCardScanSuccess(idCardInfoBean);
//    }
//
//    @Override
//    public void lklIDCardScanError(String errorCode, String errorMsg) {
//        mIdCardScanResultCallback.onIDCardError(errorCode,errorMsg);
//    }*/
//}
